<?php 

/*-----------------------------------------------------------------------------------

TABLE OF CONTENTS

- Custom fields for WP write panel - swiftthemes_metabox_create
- swiftthemes_uploader_custom_fields
- swiftthemes_metabox_handle
- swiftthemes_metabox_add
- swiftthemes_metabox_header

-----------------------------------------------------------------------------------*/



/*-----------------------------------------------------------------------------------*/
// Custom fields for WP write panel
// This code is protected under Creative Commons License: http://creativecommons.org/licenses/by-nc-nd/3.0/
/*-----------------------------------------------------------------------------------*/
// swift Metabox Options
$swift_metaboxes = array();
			
$swift_metaboxes[] = array (	"name" => "image",
							"label" => "Image",
							"type" => "upload",
							"desc" => "Upload file here...");
							    
update_option('swift_custom_template',$swift_metaboxes);      


function swiftthemes_metabox_create() {
    global $post;
    $swift_metaboxes = get_option('swift_custom_template');
    
    $seo_metaboxes = get_option('swift_custom_seo_template');  
    
    if(!empty($seo_metaboxes) AND get_option('seo_swift_hide_fields') != 'true'){
    	$swift_metaboxes = array_merge($swift_metaboxes,$seo_metaboxes);
    }

    $output = '';
    $output .= '<table class="swift_metaboxes_table">'."\n";
    foreach ($swift_metaboxes as $swift_metabox) {
    $swift_id = "swiftthemes_" . $swift_metabox["name"];
    $swift_name = $swift_metabox["name"];
    if(        
                $swift_metabox['type'] == 'text' 
		OR      $swift_metabox['type'] == 'select' 
		OR      $swift_metabox['type'] == 'checkbox' 
		OR      $swift_metabox['type'] == 'textarea'
		OR      $swift_metabox['type'] == 'calendar'
		OR      $swift_metabox['type'] == 'time'
		OR      $swift_metabox['type'] == 'radio'
		OR      $swift_metabox['type'] == 'images') {
            $swift_metaboxvalue = get_post_meta($post->ID,$swift_name,true);
			}
            
            if (empty($swift_metaboxvalue) && isset($swift_metabox['std'])) {
                $swift_metaboxvalue = $swift_metabox['std'];
            }

            if($swift_metabox['type'] == 'text'){
            
                $output .= "\t".'<tr>';
                $output .= "\t\t".'<th class="swift_metabox_names"><label for="'.$swift_id.'">'.$swift_metabox['label'].'</label></th>'."\n";
                $output .= "\t\t".'<td><input class="swift_input_text" type="'.$swift_metabox['type'].'" value="'.$swift_metaboxvalue.'" name="'.$swift_name.'" id="'.$swift_id.'"/>';
                $output .= '<span class="swift_metabox_desc">'.$swift_metabox['desc'].'</span></td>'."\n";
                $output .= "\t".'<td></td></tr>'."\n";  
                              
            }
            
            elseif ($swift_metabox['type'] == 'textarea'){
            
                $output .= "\t".'<tr>';
                $output .= "\t\t".'<th class="swift_metabox_names"><label for="'.$swift_metabox.'">'.$swift_metabox['label'].'</label></th>'."\n";
                $output .= "\t\t".'<td><textarea class="swift_input_textarea" name="'.$swift_name.'" id="'.$swift_id.'">' . $swift_metaboxvalue . '</textarea>';
                $output .= '<span class="swift_metabox_desc">'.$swift_metabox['desc'].'</span></td>'."\n";
                $output .= "\t".'<td></td></tr>'."\n";  
                              
            }
            
            elseif ($swift_metabox['type'] == 'calendar'){
            	
                $output .= "\t".'<tr>';
                $output .= "\t\t".'<th class="swift_metabox_names"><label for="'.$swift_metabox.'">'.$swift_metabox['label'].'</label></th>'."\n";
                $output .= "\t\t".'<td><input class="swift_input_calendar" type="text" name="'.$swift_name.'" id="'.$swift_id.'" value="'.$swift_metaboxvalue.'">';
                $output .= '<span class="swift_metabox_desc">'.$swift_metabox['desc'].'</span></td>'."\n";
                $output .= "\t".'<td></td></tr>'."\n";  
                              
            }
            
            elseif ($swift_metabox['type'] == 'time'){
            	
                $output .= "\t".'<tr>';
                $output .= "\t\t".'<th class="swift_metabox_names"><label for="'.$swift_id.'">'.$swift_metabox['label'].'</label></th>'."\n";
                $output .= "\t\t".'<td><input class="swift_input_time" type="'.$swift_metabox['type'].'" value="'.$swift_metaboxvalue.'" name="'.$swift_name.'" id="'.$swift_id.'"/>';
                $output .= '<span class="swift_metabox_desc">'.$swift_metabox['desc'].'</span></td>'."\n";
                $output .= "\t".'<td></td></tr>'."\n"; 
                              
            }

            elseif ($swift_metabox['type'] == 'select'){
                       
                $output .= "\t".'<tr>';
                $output .= "\t\t".'<th class="swift_metabox_names"><label for="'.$swift_id.'">'.$swift_metabox['label'].'</label></th>'."\n";
                $output .= "\t\t".'<td><select class="swift_input_select" id="'.$swift_id.'" name="'. $swift_name .'">';
                $output .= '<option value="">Select to return to default</option>';
                
                $array = $swift_metabox['options'];
                
                if($array){
                
                    foreach ( $array as $id => $option ) {
                        $selected = '';
                       
                        if(isset($swift_metabox['default']))  {                            
							if($swift_metabox['default'] == $option && empty($swift_metaboxvalue)){$selected = 'selected="selected"';} 
							else  {$selected = '';}
						}
                        
                        if($swift_metaboxvalue == $option){$selected = 'selected="selected"';}
                        else  {$selected = '';}  
                        
                        $output .= '<option value="'. $option .'" '. $selected .'>' . $option .'</option>';
                    }
                }
                
                $output .= '</select><span class="swift_metabox_desc">'.$swift_metabox['desc'].'</span></td></td><td></td>'."\n";
                $output .= "\t".'</tr>'."\n";
            }
            
            elseif ($swift_metabox['type'] == 'checkbox'){
            
                if($swift_metaboxvalue == 'true') { $checked = ' checked="checked"';} else {$checked='';}

                $output .= "\t".'<tr>';
                $output .= "\t\t".'<th class="swift_metabox_names"><label for="'.$swift_id.'">'.$swift_metabox['label'].'</label></th>'."\n";
                $output .= "\t\t".'<td><input type="checkbox" '.$checked.' class="swift_input_checkbox" value="true"  id="'.$swift_id.'" name="'. $swift_name .'" />';
                $output .= '<span class="swift_metabox_desc" style="display:inline">'.$swift_metabox['desc'].'</span></td></td><td></td>'."\n";
                $output .= "\t".'</tr>'."\n";
            }
            
            elseif ($swift_metabox['type'] == 'radio'){
            
            $array = $swift_metabox['options'];
            
            if($array){
            
            $output .= "\t".'<tr>';
            $output .= "\t\t".'<th class="swift_metabox_names"><label for="'.$swift_id.'">'.$swift_metabox['label'].'</label></th>'."\n";
            $output .= "\t\t".'<td>';
            
                foreach ( $array as $id => $option ) {

                    if($swift_metaboxvalue == $id) { $checked = ' checked';} else {$checked='';}

                        $output .= '<input type="radio" '.$checked.' value="' . $id . '" class="swift_input_radio"  name="'. $swift_name .'" />';
                        $output .= '<span class="swift_input_radio_desc" style="display:inline">'. $option .'</span><div class="swift_spacer"></div>';
                    }
                    $output .=  '</td></td><td></td>'."\n";
                    $output .= "\t".'</tr>'."\n";    
                 }
            }
			elseif ($swift_metabox['type'] == 'images')
			{
			
			$i = 0;
			$select_value = '';
			$layout = '';

			foreach ($swift_metabox['options'] as $key => $option) 
				 { 
				 $i++;
				 
				 $checked = '';
				 $selected = '';
				 if($swift_metaboxvalue != '') {
				 	if ($swift_metaboxvalue == $key) { $checked = ' checked'; $selected = 'swift-meta-radio-img-selected'; }
				 } 
				 else {
				 	if ($option['std'] == $key) { $checked = ' checked'; } 
					elseif ($i == 1) { $checked = ' checked'; $selected = 'swift-meta-radio-img-selected'; }
					else { $checked=''; }
					
				 }
					
					$layout .= '<div class="swift-meta-radio-img-label">';			
					$layout .= '<input type="radio" id="swift-meta-radio-img-' . $swift_name . $i . '" class="checkbox swift-meta-radio-img-radio" value="'.$key.'" name="'. $swift_name.'" '.$checked.' />';
					$layout .= '&nbsp;' . $key .'<div class="swift_spacer"></div></div>';
					$layout .= '<img src="'.$option.'" alt="" class="swift-meta-radio-img-img '. $selected .'" onClick="document.getElementById(\'swift-meta-radio-img-'. $swift_metabox["name"] . $i.'\').checked = true;" />';
				}
			
			$output .= "\t".'<tr>';
			$output .= "\t\t".'<th class="swift_metabox_names"><label for="'.$swift_id.'">'.$swift_metabox['label'].'</label></th>'."\n";
			$output .= "\t\t".'<td class="swift_metabox_fields">';
			$output .= $layout;
			$output .= '<span class="swift_metabox_desc">'.$swift_metabox['desc'].'</span></td></td><td></td>'."\n";
			$output .= '</td>'."\n";
			$output .= "\t".'</tr>'."\n";
						
			}
            
            elseif($swift_metabox['type'] == 'upload')
            {
				if(isset($swift_metabox["default"])) $default = $swift_metabox["default"];
				else $default = '';
            
                $output .= "\t".'<tr>';
                $output .= "\t\t".'<th class="swift_metabox_names"><label for="'.$swift_id.'">'.$swift_metabox['label'].'</label></th>'."\n";
                $output .= "\t\t".'<td class="swift_metabox_fields">'. swiftthemes_uploader_custom_fields($post->ID,$swift_name,$default,$swift_metabox["desc"]);
                $output .= '</td>'."\n";
                $output .= "\t".'</tr>'."\n";
                
            }
        }
    
    $output .= '</table>'."\n\n";
    echo $output;
}



/*-----------------------------------------------------------------------------------*/
// swiftthemes_uploader_custom_fields
/*-----------------------------------------------------------------------------------*/

function swiftthemes_uploader_custom_fields($pID,$id,$std,$desc){

    // Start Uploader
    $upload = get_post_meta( $pID, $id, true);
	$href = cleanSource($upload);
	$uploader = '';
    $uploader .= '<input class="swift_input_text" name="'.$id.'" type="text" value="'.$upload.'" />';
    $uploader .= '<div class="clear"></div>'."\n";
    $uploader .= '<input type="file" name="attachement_'.$id.'" />';
    $uploader .= '<input type="submit" class="button button-highlighted" value="Save" name="save"/>';
    if ( $href ) 
		$uploader .= '<span class="swift_metabox_desc">'.$desc.'</span></td>'."\n".'<td class="swift_metabox_image"><a href="'. $upload .'"><img src="'.get_bloginfo('template_url').'/thumb.php?src='.$href.'&w=150&h=80&zc=1" alt="" /></a>';

return $uploader;
}



/*-----------------------------------------------------------------------------------*/
// swiftthemes_metabox_handle
/*-----------------------------------------------------------------------------------*/

function swiftthemes_metabox_handle(){   
    
    global $globals;
    $swift_metaboxes = get_option('swift_custom_template');  
    
    $seo_metaboxes = get_option('swift_custom_seo_template');  
    
    if(!empty($seo_metaboxes) AND get_option('seo_swift_hide_fields') != 'true'){
    	$swift_metaboxes = array_merge($swift_metaboxes,$seo_metaboxes);
    }
       
    if(isset($_POST['post_ID']))
		$pID = $_POST['post_ID'];
    $upload_tracking = array();
	
    
    if (isset($_POST['action']) && $_POST['action'] == 'editpost'){                                   
        foreach ($swift_metaboxes as $swift_metabox) { // On Save.. this gets looped in the header response and saves the values submitted
            if($swift_metabox['type'] == 'text' 
			OR $swift_metabox['type'] == 'calendar' 
			OR $swift_metabox['type'] == 'time'
			OR $swift_metabox['type'] == 'select' 
			OR $swift_metabox['type'] == 'radio'
			OR $swift_metabox['type'] == 'checkbox' 
			OR $swift_metabox['type'] == 'textarea' 
			OR $swift_metabox['type'] == 'images' ) // Normal Type Things...
                {
                    $var = $swift_metabox["name"];
                    if (isset($_POST[$var])) {            
                        if( get_post_meta( $pID, $var ) == "" )
                            add_post_meta($pID, $var, $_POST[$var], true );
                        elseif($_POST[$var] != get_post_meta($pID, $var, true))
                            update_post_meta($pID, $var, $_POST[$var]);
                        elseif($_POST[$var] == "") {
                           delete_post_meta($pID, $var, get_post_meta($pID, $var, true));
                        }
                    }
                    elseif(!isset($_POST[$var]) && $swift_metabox['type'] == 'checkbox') { 
                        update_post_meta($pID, $var, 'false'); 
                    }      
                    else {
                          delete_post_meta($pID, $var, get_post_meta($pID, $var, true)); // Deletes check boxes OR no $_POST
                    }    
                }
          
            elseif($swift_metabox['type'] == 'upload') // So, the upload inputs will do this rather
                {
                $id = $swift_metabox['name'];
                $override['action'] = 'editpost';
                
                    if(!empty($_FILES['attachement_'.$id]['name'])){ //New upload
                    $_FILES['attachement_'.$id]['name'] = preg_replace('/[^a-zA-Z0-9._\-]/', '', $_FILES['attachement_'.$id]['name']); 
                           $uploaded_file = wp_handle_upload($_FILES['attachement_' . $id ],$override); 
                           $uploaded_file['option_name']  = $swift_metabox['label'];
                           $upload_tracking[] = $uploaded_file;
                           update_post_meta($pID, $id, $uploaded_file['url']);
                    }
                    elseif(empty( $_FILES['attachement_'.$id]['name']) && isset($_POST[ $id ])){
                        update_post_meta($pID, $id, $_POST[ $id ]); 
                    }
                    elseif($_POST[ $id ] == '')  { delete_post_meta($pID, $id, get_post_meta($pID, $id, true));
                    }
                }
               // Error Tracking - File upload was not an Image
               update_option('swift_custom_upload_tracking', $upload_tracking);
            }
            
        }
}

/*-----------------------------------------------------------------------------------*/
// swiftthemes_metabox_add
/*-----------------------------------------------------------------------------------*/

function swiftthemes_metabox_add() {
    if ( function_exists('add_meta_box') ) {
    
    	if ( function_exists('get_post_types') ) {
    		$custom_post_list = get_post_types();
			foreach ($custom_post_list as $type){
				add_meta_box('swiftthemes-settings', 'SWIFT Custom Settings','swiftthemes_metabox_create',$type,'normal');
			}
    	} else {
    		add_meta_box('swiftthemes-settings','SWIFT Custom Settings','swiftthemes_metabox_create','post','normal','high');
        	add_meta_box('swiftthemes-settings','SWIFT Custom Settings','swiftthemes_metabox_create','page','normal','high');
    	}
		
    }
}

/*-----------------------------------------------------------------------------------*/
// swiftthemes_metabox_header
/*-----------------------------------------------------------------------------------*/

function swiftthemes_metabox_header(){
?>
<script type="text/javascript">

        jQuery('form#post').attr('enctype','multipart/form-data');
        jQuery('form#post').attr('encoding','multipart/form-data');
        
         //JQUERY DATEPICKER
		jQuery('.swift_input_calendar').each(function (){
			jQuery('#' + jQuery(this).attr('id')).datepicker({showOn: 'button', buttonImage: '<?php echo get_bloginfo('template_directory');?>/functions/images/calendar.gif', buttonImageOnly: true});
		});
		
		//JQUERY TIME INPUT MASK
		jQuery('.swift_input_time').each(function (){
			jQuery('#' + jQuery(this).attr('id')).mask("99:99");
		});
		
        jQuery('.swift_metaboxes_table th:last, .swift_metaboxes_table td:last').css('border','0');
        var val = jQuery('input#title').attr('value');
        if(val == ''){ 
        jQuery('.swift_metabox_fields .button-highlighted').after("<em class='swift_red_note'>Please add a Title before uploading a file</em>");
        };
		jQuery('.swift-meta-radio-img-img').click(function(){
				jQuery(this).parent().find('.swift-meta-radio-img-img').removeClass('swift-meta-radio-img-selected');
				jQuery(this).addClass('swift-meta-radio-img-selected');
				
			});
			jQuery('.swift-meta-radio-img-label').hide();
			jQuery('.swift-meta-radio-img-img').show();
			jQuery('.swift-meta-radio-img-radio').hide();
        <?php //Errors
        $error_occurred = false;
        $upload_tracking = get_option('swift_custom_upload_tracking');
        if(!empty($upload_tracking)){
        $output = '<div style="clear:both;height:20px;"></div><div class="errors"><ul>' . "\n";
            $error_shown == false;
            foreach($upload_tracking as $array )
            {
                 if(array_key_exists('error', $array)){
                        $error_occurred = true;
                        ?>
                        jQuery('form#post').before('<div class="updated fade"><p>swiftThemes Upload Error: <strong><?php echo $array['option_name'] ?></strong> - <?php echo $array['error'] ?></p></div>');
                        <?php
                }
            }
        }
		
        delete_option('swift_upload_custom_errors');
        ?>
    });

</script>
<style type="text/css">
.swift_input_text { margin:0 0 10px 0; background:#f4f4f4; color:#444; width:80%; font-size:11px; padding: 5px;}
.swift_input_select { margin:0 0 10px 0; background:#f4f4f4; color:#444; width:60%; font-size:11px; padding: 5px;}
.swift_input_checkbox { margin:0 10px 0 0; }
.swift_input_radio { margin:0 10px 0 0; }
.swift_input_radio_desc { font-size: 12px; color: #666 ; }
.swift_spacer { display: block; height:5px}
.swift_metabox_desc { font-size:10px; color:#aaa; display:block}
.swift_metaboxes_table{ border-collapse:collapse; width:100%}
.swift_metaboxes_table tr:hover th,
.swift_metaboxes_table tr:hover td { background:#f8f8f8}
.swift_metaboxes_table th,
.swift_metaboxes_table td{ border-bottom:1px solid #ddd; padding:10px 10px;text-align: left; vertical-align:top}
.swift_metabox_names { width:20%}
.swift_metabox_fields { width:70%}
.swift_metabox_image { text-align: right;}
.swift_red_note { margin-left: 5px; color: #c77; font-size: 10px;}
.swift_input_textarea { width:80%; height:120px;margin:0 0 10px 0; background:#f0f0f0; color:#444;font-size:11px;padding: 5px;}
.swift-meta-radio-img-img { border:3px solid #fff; margin:0 5px 10px 0; display:none; cursor:pointer;}
.swift-meta-radio-img-selected { border:3px solid #ccc}
.swift-meta-radio-img-label { font-size:12px}
.swift-meta-radio-img-img:hover {opacity:.8; }


.swift_date{}
.swift_date input{background:#f1f1f1; border:solid 1px #ddd;font-size:12px!important; 
}
</style>
<?php
}


function swift_custom_enqueue($hook) {
  	if ($hook == 'post.php' OR $hook == 'post-new.php' OR $hook == 'page-new.php' OR $hook == 'page.php') {
		add_action('admin_head', 'swiftthemes_metabox_header');
		
  	}
}

add_action('admin_enqueue_scripts','swift_custom_enqueue',10,1);
add_action('edit_post', 'swiftthemes_metabox_handle');
add_action('admin_menu', 'swiftthemes_metabox_add'); // Triggers swiftthemes_metabox_create

?>