<?php
 $opt = get_option('swift_opt');
 $design_opt = get_option('swift_design_opt');
/**
 * Loads all the core files
 * Initializes widgets
 * Add action hooks and filters
 */

// Directory constants
define('INCLUDES', TEMPLATEPATH . '/includes');
define('ADMIN', TEMPLATEPATH . '/admin');
define('WIDGETS', TEMPLATEPATH . '/widgets');
define('LAYOUTS', TEMPLATEPATH . '/layouts');

// Defining uploads directory parameters
$wud = wp_upload_dir();
define('U_DIR', $wud['basedir']);
define('U_URL', $wud['baseurl']);
define('TEMPLATE_URL',get_bloginfo('template_url'));

require_once (INCLUDES . '/sidebar-init.php'); 	// Initializes the sidebars
require_once (INCLUDES . '/thumb.php');        	// Add's thumbnails to the post and fetches them when called for
require_once (INCLUDES . '/wp-pagenavi.php');  	// Add's wp page nav support, script by Lester Chann
require_once (INCLUDES. '/custom-functions.php');	// Some MISC functions
//require_once (INCLUDES. '/custom-post-types.php');	// We define our custom post types here

require_once (ADMIN. '/admin-header.php');     	//Header of options page
require_once (ADMIN. '/admin-core.php');       	// Work horse for SWIFT admin options.
require_once (ADMIN. '/swift-options-init.php');	// SWIFT options array
require_once (ADMIN. '/swift-design-options-init.php');	//SWIFT design options array

require_once (ADMIN. '/create-styles.php');		// Generates custom-styles.css files
require_once (ADMIN. '/create-js-file.php');	// Generates the javaScript file dynamically

require_once (ADMIN. '/admin-custom.php');	// Adds meta box to write post page



// Wordpress loops, used on home page and archives.
require_once (LAYOUTS. '/blog-loop.php');
require_once (LAYOUTS. '/mag-loop.php');

require_once (WIDGETS . '/widgets.php'); // Adds widgets
require_once (WIDGETS . '/widget-functions.php');	// Functions for the above loaded widgets


/**
 * Initializing our widgets
 */
add_action('widgets_init', create_function('', 'return register_widget("swiftTabs");'));
add_action('widgets_init', create_function('', 'return register_widget("swiftPopularPosts");')); 
add_action('widgets_init', create_function('', 'return register_widget("swiftAdsWidget");')); 
add_action('widgets_init', create_function('', 'return register_widget("SubscribeBox");')); 
add_action('widgets_init', create_function('', 'return register_widget("HomePageOnlyText");')); 
add_action('widgets_init', create_function('', 'return register_widget("SwiftLite");')); 
 

/**
 * WPMU fix by edelwater @ farmvillie.org
 */
add_action('admin_init', 'swift_options_init' );
function swift_options_init(){
	register_setting( '', 'swift_opt' );
	register_setting( '', 'swift_design_opt' );
	register_setting( '', 'swift_random' );
}

add_action( 'init', 'register_my_menus' );
function register_my_menus() {
register_nav_menus(
array(
'top-nav' => __( 'Top Navigation' ),
'bottom-nav' => __( 'Bottom Navigation' ),
'footer-links' => __( 'Footer Links' )
)
);
} 
?>